%define Werror_cflags %{nil}

Summary:	Network traffic analyzer
Summary(de): Analyse des Datenverkehrs im Netzwerk.
Name:		wireshark
Version:	2.4.5
Release:	%mkrel 1
License:	GPLv2+ and GPLv3
Group:		Monitoring
URL:		http://www.wireshark.org
Source0:	http://www.wireshark.org/download/src/%{name}-%{version}.tar.xz
Source1:    wireshark.desktop
Patch0:		wireshark-1.12.0-do-not-fail-on-chgrp-chmod.patch
#-------------------------------------------
Requires:	dumpcap
Requires:	xdg-utils
Requires:   libcap-utils
#-------------------------------------------
BuildRequires: doxygen
BuildRequires: openssl-devel
BuildRequires: pcre-devel
BuildRequires: bison
BuildRequires: flex
BuildRequires: libtool
BuildRequires: lib64cap-devel
BuildRequires: lib64ext2fs-devel
BuildRequires: lib64gcrypt-devel
BuildRequires: lib64geoip-devel
BuildRequires: lib64glib2.0-devel
BuildRequires: lib64gnutls-devel
BuildRequires: lib64gpg-error-devel
BuildRequires: lib64krb53-devel
BuildRequires: lib64lua5.2-devel
BuildRequires: lib64nl3-devel
BuildRequires: lib64pcap-devel
BuildRequires: lib64portaudio-devel
BuildRequires: lib64qt5core-devel
BuildRequires: lib64qt5gui-devel
BuildRequires: lib64qt5multimedia-devel
BuildRequires: lib64qt5printsupport-devel
BuildRequires: lib64qt5widgets-devel
BuildRequires: lib64smi-devel
BuildRequires: lib64snappy-devel
BuildRequires: lib64speex1-devel
BuildRequires: lib64xml2-devel
BuildRequires: mesa-devel
BuildRequires: qtbase5-common-devel
BuildRequires: zlib1-devel
#-------------------------------------------


%description
Wireshark is a network traffic analyzer for Unix-ish operating systems. It is
based on Qt5, a graphical user interface library, and libpcap, a packet
capture and filtering library.

Please logout and back in again after installing this package to gain
access to the capture interfaces.


%description -l de
Wireshark ist eine Analyse des Datenverkehrs im Netzwerk für UNIX Betriebssysteme. 
Es basiert auf Qt5, einer grafischen Benutzerschnittstellenbibliothek und libpcap,
einer Paketerfassungs- und Filter Bibliothek. 


%package devel
Summary:	Development files for %{name}
Group:		Development/Libraries
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	wireshark-devel = %{version}-%{release}
Requires:   %{name}

%description devel
This package contains files used for development with %{name}.

%package	tools
Summary:	Tools for manipulating capture files
Summary(de): Werkzeuge zur Bearbeitung von erfassten Dateien
Group:		Monitoring

%description	tools
Set of tools for manipulating capture files. Contains:

- editcap - Edit and/or translate the format of capture files
- mergecap - Merges two capture files into one
- text2cap - Generate a capture file from an ASCII hexdump of packets

%description tools -l de
Die Sammlung von Werkzeugen zur Bearbeitung von erfassten Dateien enthält:

- editcap - bearbeiten und/oder übersetzt das Format der erfassen Dateien.
- Mergecap - fügt zwei erfasste Dateien zu einer zusammen.
- Text2cap - Erstelle eine erfasste Datei aus hexadezimalen ASCII Paketen.


%package -n	tshark
Summary:	Text-mode network traffic and protocol analyzer
Summary(de): Netzwerk-Datenverkehr und Protokollanalyse im Textmodus
Group:		Monitoring
Requires:	dumpcap

%description -n	tshark
Tshark is a network protocol analyzer. It lets you capture packet data from a
live network, or read packets from a previously saved capture file, either
printing a decoded form of those packets to the standard output or writing the
packets to a file. Twireshark's native capture file format is libpcap format,
which is also the format used by tcpdump and various other tools.


%description -n tshark -l de
Twireshark ist ein Programm zur Analyse von Netzwerkprotokollen. Sie können die 
Paketdaten aus einem Live-Netzwerk erfassen, oder Pakete aus einer zuvor 
gespeicherten Datenerfassung lesen. Sie können die entschlüsselten Pakete entweder 
ausdrucken, oder sie in einer Datei speichern.


%package -n	rawshark
Summary:	Dump and analyze raw libpcap data
Summary(de): Analyse des Datenverkehrs im Netzwerk.
Group:		Monitoring

%description -n	rawshark
Rawshark reads a stream of packets from a file or pipe, and prints a line
describing its output, followed by a set of matching fields for each packet on
stdout.

%description -n rawshark -l de
Twireshark ist ein Programm zur Analyse von Netzwerkprotokollen.


%package -n	dumpcap
Summary:	Network traffic dump tool
Summary(de): Analyse des Datenverkehrs im Netzwerk.
Group:		Monitoring

%description -n	dumpcap
Dumpcap is a network traffic dump tool. It lets you capture packet data from a
live network and write the packets to a file. Many wireshark utilities require it.

%description -n dumpcap -l de
Twireshark ist ein Programm zur Analyse von Netzwerkprotokollen.


%prep
%setup -q
%patch0 -p1


%build
./autogen.sh
export PATH=$PATH:%{_qt5_bindir}
export CFLAGS="%{optflags} -fPIC"
export CXXFLAGS="%{optflags} -fPIC"
%configure2_5x \
    --disable-static \
    --disable-warnings-as-errors \
    --enable-warnings-as-errors=no \
    --disable-usr-local \
    --enable-wireshark \
    --enable-packet-editor \
    --enable-tshark \
    --enable-editcap \
    --enable-capinfos \
    --enable-mergecap \
    --enable-text2pcap \
    --enable-dftest \
    --enable-randpkt \
    --enable-airpcap \
    --enable-dumpcap \
    --enable-rawshark \
    --enable-ipv6 \
    --enable-setuid-install \
    --with-gnutls=yes \
    --with-gcrypt=yes \
    --with-geoip=yes \
    --with-krb5 \
    --with-adns=no \
    --with-gtk3=no \
    --with-qt=yes \
    --with-libnl=3 \
    --with-libsmi=%{_prefix} \
    --with-pcap=%{_prefix} \
    --with-zlib=%{_prefix} \
    --with-lua=%{_prefix} \
    --with-portaudio=%{_prefix} \
    --with-libcap=%{_prefix} \
    --with-ssl=%{_prefix} \
    --with-plugins=%{_libdir}/%{name}

%make

%install
rm -rf %buildroot
%make_install


# link to main executable
mv %{buildroot}%{_bindir}/wireshark %{buildroot}%{_bindir}/wireshark-qt
ln -s wireshark-qt %{buildroot}%{_bindir}/wireshark

chmod a+r %{buildroot}%{_bindir}/dumpcap

# icons
install -Dpm0644 image/wsicon16.png %{buildroot}%{_miconsdir}/%{name}.png
install -Dpm0644 image/wsicon32.png %{buildroot}%{_iconsdir}/%{name}.png
install -Dpm0644 image/wsicon48.png %{buildroot}%{_liconsdir}/%{name}.png

install -m 0644 %SOURCE1 %{buildroot}/%{_datadir}/applications/wireshark.desktop

# remove uneeded files
find %{buildroot} -name "*.la" -delete
rm -f %{buildroot}/%{_datadir}/applications/wireshark-gtk.desktop

# install includes
mkdir -p %{buildroot}%{_includedir}/wireshark
for include in `find epan -type f -name '*.h'`; do
        mkdir -p %{buildroot}%{_includedir}/wireshark/`dirname $include`
        install -m 0644 $include %{buildroot}%{_includedir}/wireshark/`dirname $include`
done

# remaining include files
install -m 0644 *.h %{buildroot}%{_includedir}/wireshark
mkdir -p %{buildroot}%{_includedir}/wireshark/wiretap
install -m 0644 wiretap/*.h %{buildroot}%{_includedir}/wireshark/wiretap
mkdir -p %{buildroot}%{_includedir}/wireshark/codecs
install -m 0644 codecs/*.h %{buildroot}%{_includedir}/wireshark/codecs
mkdir -p %{buildroot}%{_includedir}/wireshark/wsutil
install -m 0644 wsutil/*.h %{buildroot}%{_includedir}/wireshark/wsutil

# pkg-config support
install -d %{buildroot}%{_libdir}/pkgconfig/
cat > %{buildroot}%{_libdir}/pkgconfig/wireshark.pc << EOF
prefix=%{_prefix}
exec_prefix=%{_prefix}
libdir=%{_libdir}
includedir=%{_includedir}/wireshark
plugindir=%{_libdir}/wireshark

Name: wireshark
Description: wireshark network packet dissection library
Version: 2.4.5

Requires:
Libs: -L\${libdir} -lwireshark
Cflags: -I\${includedir}
EOF

%pre -n dumpcap
if ! getent group wireshark > /dev/null ;then
	%{_sbindir}/groupadd -r -f wireshark
fi

%posttrans -n dumpcap
SYSUSERS=$(grep [0-9][0-9][0-9]:.*/home /etc/passwd | grep -f /etc/shells | cut -d: -f1)
for idx in $SYSUSERS
do
%{_sbindir}/usermod -a -G wireshark $idx > /dev/null 2>&1
done


%files -n dumpcap
%attr(4750, root, wireshark) %{_bindir}/dumpcap
%{_mandir}/man1/dumpcap.1*

%files
%{_bindir}/%{name}
%{_bindir}/%{name}-qt

%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*.so
%{_datadir}/%{name}
%{_iconsdir}/*.png
%{_miconsdir}/*.png
%{_liconsdir}/*.png
%{_iconsdir}/hicolor/*/*/*.png
%{_iconsdir}/hicolor/*/*/*.svg
%{_mandir}/man1/%{name}.1*
%{_mandir}/man4/%{name}-filter.4*
%{_datadir}/applications/*.desktop
%{_datadir}/appdata/%{name}.appdata.xml
%{_datadir}/mime/packages/%{name}.xml
%{_libdir}/libwireshark.so.*
%{_libdir}/libwiretap.so.*
%{_libdir}/libwscodecs.so.*
%{_libdir}/libwsutil.so.*



%files tools
%{_bindir}/capinfos
%{_bindir}/captype
%{_bindir}/dftest
%{_bindir}/editcap
%{_bindir}/idl2wrs
%{_bindir}/mergecap
%{_bindir}/randpkt
%{_bindir}/reordercap
%{_bindir}/text2pcap
%{_bindir}/sharkd
%{_libdir}/%{name}/extcap/androiddump
%{_libdir}/%{name}/extcap/randpktdump
%{_libdir}/%{name}/extcap/udpdump
%{_libdir}/%{name}/extcap/ciscodump
%{_libdir}/%{name}/extcap/sshdump
%{_mandir}/man1/androiddump*
%{_mandir}/man1/capinfo*
%{_mandir}/man1/dftest*
%{_mandir}/man1/editcap*
%{_mandir}/man1/mergecap*
%{_mandir}/man1/randpkt*
%{_mandir}/man1/reordercap*
%{_mandir}/man1/text2pcap*
%{_mandir}/man4/extcap*
%{_mandir}/man1/sshdump*
%{_mandir}/man1/udpdump*
   
%files -n tshark
%{_bindir}/tshark
%{_mandir}/man1/tshark*

%files -n rawshark
%{_bindir}/rawshark
%{_mandir}/man1/rawshark.1*


%files devel
%doc ChangeLog
%{_includedir}/wireshark
%{_libdir}/libwireshark.so
%{_libdir}/libwiretap.so
%{_libdir}/libwscodecs.so
%{_libdir}/libwsutil.so
%{_libdir}/pkgconfig/*.pc


%changelog
* Mon Feb 26 2018 bb2 <bb2> - 2.4.5-1pclos2018
- new version

* Tue Dec 05 2017 bb2 <bb2> - 2.4.3-1pclos2017
- new version

* Sun Aug 06 2017 bb2 <bb2> - 2.4.0-3pclos2017
- only need wireshark in one place in menu

* Sun Aug 06 2017 bb2 <bb2> - 2.4.0-2pclos2017
- fix extra desktop files

* Sat Aug 05 2017 bb2 <bb2> - 2.4.0-1pclos2017
- new version based on Qt5

* Fri Jul 21 2017 bb2 <bb2> - 2.2.8-1pclos2017
- new version

* Fri Jun 02 2017 bb2 <bb2> - 2.2.7-1pclos2017
- update

* Tue May 02 2017 bb2 <bb2> - 2.2.6-2pclos2017
- rebuild

* Fri Apr 14 2017 bb2 <bb2> - 2.2.6-1pclos2017
- new version
